<template lang="pug">
  .demo
    .btns-block
      .sort-block
        span.title {{sortItems.title}}
        button.btn(
          type="button"
          :value="item.value"
          v-for="item in sortItems.items"
          @click="sortList(item.value)"
          :class="[sortValue === item.value ? 'active' : '']")
          span {{item.text}}
          i.material-icons(style="font-size: 12px" :style="`transform: rotate(${descending ? '180' : '0'}deg)`" v-if="sortValue === item.value") arrow_downward
      .filter-block
        span.title {{filterItems.title}}
        button.btn(
          type="button"
          :value="item.value"
          v-for="item in filterItems.items"
          @click="filterValue = item.value"
          :class="[filterValue === item.value ? 'active' : '']") {{item.text}}

    .hr-line

    template(v-if="videoList.length !== 0")
      card(:info="item" v-for="item in videoList" :key="item.id")
    template(v-else)
      .loading.fa-3x(v-if="isInit")
        i(class="fas fa-circle-notch fa-spin")
      .result(v-else) 沒有篩選結果

</template>

<script>
  import card from '@/components/Card'

  export default {
    name: 'demo',
    data () {
      return {
        items: [],
        sortValue: 'publish',
        filterValue: 0,
        isInit: true,
        descending: false
      }
    },
    async created () {
      this.isInit = true
      this.items = await this.$store.dispatch('fetchVideos')
        .then(response => {
          this.isInit = false
          return response.data.data
        })
        .catch(() => {
          this.isInit = false
        })
    },
    components: {
      card
    },
    computed: {
      videoList () {
        return this.items.filter(item => {
          if (this.filterValue !== 0) {
            switch (this.filterValue) {
              case 1:
                return item.duration < 5 * 60
              case 2:
                return item.duration >= 5 * 60 && item.duration <= 10 * 60
              case 3:
                return item.duration > 10 * 60
            }
          } else {
            return item
          }
        })
      },
      sortItems () {
        return {
          title: '排序',
          items: [
            {text: '發布時間', value: 'publish'},
            {text: '觀看次數', value: 'views'},
            {text: '收藏次數', value: 'collectCount'}
          ]
        }
      },
      filterItems () {
        return {
          title: '長度',
          items: [
            {text: '不限', value: 0},
            {text: '5 分鐘以下', value: 1},
            {text: '5 - 10 分鐘', value: 2},
            {text: '超過 10 分鐘', value: 3}
          ]
        }
      }
    },
    methods: {
      sortList (sort) {
        this.sortValue = sort
        this.descending = !this.descending
        this.items = this.$__bubbleSort(this.items, sort)
      },
      $__bubbleSort (items, type) {
        let arr = items.slice()
        let arrLength = arr.length

        for (let i = 0; i < arrLength; i++) {
          for (let j = 0; j < arrLength - 1 - i; j++) {
            if (!this.descending) {
              if (arr[j][type] > arr[j + 1][type]) {
                [arr[j], arr[j + 1]] = [arr[j + 1], arr[j]]
              }
            } else {
              if (arr[j][type] < arr[j + 1][type]) {
                [arr[j], arr[j + 1]] = [arr[j + 1], arr[j]]
              }
            }
          }
        }
        return arr
      }
    }
  }
</script>

<style lang="sass" scoped>
  =flex
    display: flex
    justify-content: center
    align-items: center

  =size($w, $h:$w)
    width: $w
    height: $h


  .demo
    +flex
    +size(100%)
    max-width: 1366px
    flex-wrap: wrap
    justify-content: space-between
    margin: 0 auto

    .btns-block
      +size(100%)
      +flex
      justify-content: flex-start
      flex-wrap: wrap

      .sort-block, .filter-block
        +flex
        margin-top: 4px
        white-space: nowrap
      .title
        margin: 0 24px
        /*font-family: NotoSansCJKtc-Medium*/
        font-size: 14px
        color: #787878
        letter-spacing: 0
        line-height: 21px
        font-weight: bolder
      .btn
        /*font-family: NotoSansCJKtc-Regular*/

        font-size: 12px
        color: #787878
        letter-spacing: 0
        line-height: 16px
        border-radius: 4px
        margin: 0 4px
        padding: 4px 8px
        border: unset
        background-color: #fff
        +flex
        &:hover
          cursor: pointer
        &.active
          background: #4283E4
          color: #fff
    .hr-line
      border: .5px solid #D8D8D8
      width: 100%
      margin: 6px 0 31px 0
    .loading, .result
      +flex
      +size(100%)

  @media only screen and (max-width: 800px)
    .demo
      justify-content: space-evenly
      .btns-block
        .title
          margin: 0 10px
</style>
